/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file MustDefines.h
 *       @see MustDefines.
 *
 *  @date 17.08.2011
 *  @author Mathias Korepkat
 */

#include <list>
#include <set>
#include "mpi.h"
#include <stdint.h>
#include "MustEnums.h"

#ifndef MUSTDEFINES_H
#define MUSTDEFINES_H

#ifdef __cplusplus
#   define EXTERN extern "C"
#else
#   define EXTERN extern
#endif

/**
 * generate fortran bindings
 */
#define GENERATE_F77_BINDINGS(lower_case, \
                              upper_case, \
                              wrapper_function, \
                              signature, \
                              params) \
  EXTERN void lower_case signature; \
  EXTERN void lower_case signature { wrapper_function params; } \
  EXTERN void lower_case##_ signature; \
  EXTERN void lower_case##_ signature { wrapper_function params; } \
  EXTERN void lower_case##__ signature; \
  EXTERN void lower_case##__ signature { wrapper_function params; } \
  EXTERN void upper_case signature; \
  EXTERN void upper_case signature { wrapper_function params; }

#ifndef MUST_MAX_NUM_STACKLEVELS
#define MUST_MAX_NUM_STACKLEVELS 10
#endif

#ifndef MUST_MAX_TOTAL_INFO_SIZE
#define MUST_MAX_TOTAL_INFO_SIZE 4096
#endif

#endif /*MUSTDEFINES_H*/
