/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file MustTypes.h
 *       @see MustTypes.
 *
 *  @date 20.05.2011
 *  @author Joachim Protze
 */

#include <list>
#include <set>
#include <stdint.h>
#include "MustEnums.h"

#ifndef MUSTTYPES_H
#define MUSTTYPES_H

/**
 * Datatype used for MPI communicator handles.
 */
// TODO: think about negative values (especially for lb!) 
//           <-/-> MPI-2.2, 2.5.6 !!!

typedef int64_t MustAddressType;
//typedef long MustAddressType;
//typedef int64_t MustLBType;

/**
 * Datatype used for MPI request handles.
 */
typedef int MustRequestType;

/**
 * Datatype used for MPI datatype handles.
 */
typedef int MustDatatypeType;

/**
 * Datatype used for MPI operation handles.
 */
typedef int MustOpType;

/**
 * Datatype used for MPI key-value handles.
 */
typedef int MustKeyvalType;

/**
 * Datatype used for MPI communicator handles.
 */
typedef int MustCommType;

/**
 * Datatype used to represent MPI group handles.
 */
typedef int MustGroupType;

/**
 * Datatype used to represent MPI error handles.
 */
typedef int MustErrType;

/**
 * Datatype used to represent MPI error handles.
 */
typedef uint64_t MustRemoteIdType;

/**
 * Datatype used for Typemaps.
 */

typedef std::list<std::pair<MustMpiDatatypePredefined, MustAddressType> > MustTypemapType;

/**
 * Datatype used for Typesigs.
 */

typedef std::list<std::pair<int, MustMpiDatatypePredefined> > MustTypesigType;

#endif /*MUSTTYPES_H*/
