/*
 * MUST (Marmot Umpire Scalable Tool)
 * Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2012
 * Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2012
 *
 * See the file LICENSE.txt in the package base directory for details
 */

/**
 * @file BaseApi.h
 * 		P call definition for MustBase API calls.
 *
 * @author Tobias Hilbrich
 * @date 10.01.2011
 */

#ifndef BASE_API_H
#define BASE_API_H

#include "BaseIds.h"
#include "mustConfig.h"

// handleNewLocation
inline int PhandleNewLocation (
		MustParallelId pId,
		MustLocationId lId,
		char* callName,
		int callNameLen
#ifdef USE_CALLPATH
        ,
        int numStackLevels,
        int stackInfosLength, /*Total length of char array for all entries of stack levels*/
        int indicesLength, /*=numStackLevels*3; used for convenience*/
        int* infoIndices, /*Array of size 3*numStackLevels with indices to the individual information pieces, for each level infoIndices[level*3+0]=symName, infoIndices[level*3+1]=lineOffset, infoIndices[level*3+2]=fileModule*/
        char* stackInfos /*All information pieces of all stack levels concatenated, of length stackInfosLength*/
#endif
        ) {return 0;}

typedef int (*handleNewLocationP) (
		MustParallelId pId,
		MustLocationId lId,
		char* callName,
		int callNameLen
#ifdef USE_CALLPATH
        ,
        int numStackLevels,
        int stackInfosLength, /*Total length of char array for all entries of stack levels*/
        int indicesLength, /*=numStackLevels*3; used for convenience*/
        int* infoIndices, /*Array of size 3*numStackLevels with indices to the individual information pieces, for each level infoIndices[level*3+0]=symName, infoIndices[level*3+1]=lineOffset, infoIndices[level*3+2]=fileModule*/
        char* stackInfos /*All information pieces of all stack levels concatenated, of length stackInfosLength*/
#endif
        );

// Call to pass a location ID to another place on the same level
inline int PpassLocationAcross (
        MustParallelId pId,
        MustLocationId lId,
        char* callName,
        int callNameLen
#ifdef USE_CALLPATH
        ,
        int numStackLevels,
        int stackInfosLength, /*Total length of char array for all entries of stack levels*/
        int indicesLength, /*=numStackLevels*3; used for convenience*/
        int* infoIndices, /*Array of size 3*numStackLevels with indices to the individual information pieces, for each level infoIndices[level*3+0]=symName, infoIndices[level*3+1]=lineOffset, infoIndices[level*3+2]=fileModule*/
        char* stackInfos /*All information pieces of all stack levels concatenated, of length stackInfosLength*/
#endif
        ) {return 0;}

typedef int (*passLocationAcrossP) (
        MustParallelId pId,
        MustLocationId lId,
        char* callName,
        int callNameLen,
#ifdef USE_CALLPATH
        int numStackLevels,
        int stackInfosLength, /*Total length of char array for all entries of stack levels*/
        int indicesLength, /*=numStackLevels*3; used for convenience*/
        int* infoIndices, /*Array of size 3*numStackLevels with indices to the individual information pieces, for each level infoIndices[level*3+0]=symName, infoIndices[level*3+1]=lineOffset, infoIndices[level*3+2]=fileModule*/
        char* stackInfos, /*All information pieces of all stack levels concatenated, of length stackInfosLength*/
#endif
        int toPlaceId
        );

// handleNewMessage
inline int PhandleNewMessage (
		int msgId,
		int hasLocation,
		MustParallelId pId,
		MustLocationId lId,
		int msgType,
		char* text,
		int textLen,
		int numReferences,
		MustParallelId *refPIds,
		MustLocationId *refLIds)
{return 0;}

// finalizeNotify
inline int PfinalizeNotify () {return 0;}

typedef int (*finalizeNotifyP) ();

#endif /*BASE_API_H*/
